#include "cuda_runtime.h"

template < unsigned block_size, typename T >
__device__ void red_kernel(unsigned tid, T* shared_buf)
{
    for (unsigned int s = 1; s < blockDim.x; s *= 2)
    {
        if (tid % (2 * s) == 0)
            shared_buf[tid] += shared_buf[tid + s];
        __syncthreads();
    }
}