#include "cuda_runtime.h"

template < unsigned block_size, typename T >
__device__ void red_kernel(unsigned tid, T* shared_buf)
{
    for (unsigned int s = blockDim.x / 2; s > 0; s >>= 1)
    {
        if (tid < s)
            shared_buf[tid] += shared_buf[tid + s];
        __syncthreads();
    }
}